/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.gremwell.parsers;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author alla
 */
public class JsonParserTest {
    // {a:["lalala","yohoho"],b:1}

    static JsonParser instance = new JsonParser();
    static String request = "HTTP/1.1 200 OK\r\n\r\n{a:[\"lalala\",\"yohoho\"],b:1}";

    public JsonParserTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
        instance.parse(request);
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }

    @Before
    public void setUp() {
    }

    @After
    public void tearDown() {
    }

    /**
     * Test of getParameter method, of class JsonParser.
     */
    @Test
    public void testGetParameter() {
        System.out.println("getParameter");
        for (int i = 0; i < instance.getParametersNumber(); i++) {
            System.out.println(instance.getParameter(i).getValue());
        }
        RequestParameter result = instance.getParameter(0);
        assertEquals("a", result.getValue());
        assertEquals(20, result.getStartOffset());
        assertEquals(21, result.getEndOffset());
        result = instance.getParameter(1);
        assertEquals("lalala", result.getValue());
        assertEquals(24, result.getStartOffset());
        assertEquals(30, result.getEndOffset());
    }

    /**
     * Test of getParametersNumber method, of class JsonParser.
     */
    @Test
    public void testGetParametersNumber() {
        System.out.println("getParametersNumber");
        int expResult = 4;
        int result = instance.getParametersNumber();
        assertEquals(expResult, result);
    }
}